Package org.springframework.beans.factory.config

# Class YamlMapFactoryBean

java.lang.Object
org.springframework.beans.factory.config.YamlProcessor
org.springframework.beans.factory.config.YamlMapFactoryBean

All Implemented Interfaces:
  `FactoryBean<Map<String,Object>>`, `InitializingBean`

public class YamlMapFactoryBean extends YamlProcessor implements FactoryBean<Map<String,Object>>, InitializingBean
Factory for a `Map` that reads from a YAML source, preserving the YAML-declared value types and their structure.

YAML is a nice human-readable format for configuration, and it has some useful hierarchical properties. It's more or less a superset of JSON, so it has a lot of similar features.

If multiple resources are provided the later ones will override entries in the earlier ones hierarchically; that is, all entries with the same nested key of type `Map` at any depth are merged. For example:

     foo:
       bar:
        one: two
     three: four

plus (later in the list)

     foo:
       bar:
        one: 2
     five: six

results in an effective input of

     foo:
       bar:
        one: 2
     three: four
     five: six

Note that the value of "foo" in the first document is not simply replaced with the value in the second, but its nested values are merged.

Requires SnakeYAML 2.0 or higher, as of Spring Framework 6.1.

Since:
  4.1
Author:
  Dave Syer, Juergen Hoeller

## Nested Class Summary

## Nested classes/interfaces inherited from class org.springframework.beans.factory.config.YamlProcessor

`YamlProcessor.DocumentMatcher, YamlProcessor.MatchCallback, YamlProcessor.MatchStatus, YamlProcessor.ResolutionMethod`

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`YamlMapFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.
`protected Map<String,Object>`
`createMap()`
Template method that subclasses may override to construct the object returned by this factory.
`Map<String,Object>`
`getObject()`
Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<?>`
`getObjectType()`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean`
`isSingleton()`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void`
`setSingleton(boolean singleton)`
Set if a singleton should be created, or a new object on each request otherwise.

### Methods inherited from class org.springframework.beans.factory.config.YamlProcessor

`createYaml, getFlattenedMap, process, setDocumentMatchers, setMatchDefault, setResolutionMethod, setResources, setSupportedTypes`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### YamlMapFactoryBean

public YamlMapFactoryBean()

## Method Details

### setSingleton

public void setSingleton(boolean singleton)
Set if a singleton should be created, or a new object on each request otherwise. Default is `true` (a singleton).

### isSingleton

public boolean isSingleton()
Description copied from interface: `FactoryBean`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

NOTE: If a FactoryBean indicates that it holds a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

The default implementation returns `true`, since a `FactoryBean` typically manages a singleton instance.

Specified by:
  `isSingleton` in interface `FactoryBean<Map<String,Object>>`
Returns:
  whether the exposed object is a singleton
See Also:
  - `FactoryBean.getObject()`
  - `SmartFactoryBean.isPrototype()`

### afterPropertiesSet

public void afterPropertiesSet()
Description copied from interface: `InitializingBean`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.

This method allows the bean instance to perform validation of its overall configuration and final initialization when all bean properties have been set.

Specified by:
  `afterPropertiesSet` in interface `InitializingBean`

### getObject

@Nullable public Map<String,Object> getObject()
Description copied from interface: `FactoryBean`
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design patterns.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

FactoryBeans are allowed to return `null` objects. The bean factory will consider this as a normal value to be used and will not throw a `FactoryBeanNotInitializedException` in this case. However, FactoryBean implementations are encouraged to throw `FactoryBeanNotInitializedException` themselves, as appropriate.

Specified by:
  `getObject` in interface `FactoryBean<Map<String,Object>>`
Returns:
  an instance of the bean (can be `null`)
See Also:
  - `FactoryBeanNotInitializedException`

### getObjectType

public Class<?> getObjectType()
Description copied from interface: `FactoryBean`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that create a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore, it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Specified by:
  `getObjectType` in interface `FactoryBean<Map<String,Object>>`
Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  - `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### createMap

protected Map<String,Object> createMap()
Template method that subclasses may override to construct the object returned by this factory.

Invoked lazily the first time `getObject()` is invoked in case of a shared singleton; else, on each `getObject()` call.

The default implementation returns the merged `Map` instance.

Returns:
  the object returned by this factory
See Also:
  - `YamlProcessor.process(MatchCallback)`